dtmc

module Alice
alice_has_message: bool init false;
alice_sent_message_to_sn1: bool init false;

[] alice_has_message = true -> 0.9:(alice_has_message' = false) + 0.1:(alice_has_message' = false) & (alice_sent_message_to_sn1' = true);

[sn1bobmessage] sn1bob_relays_message = true -> 1.0:(alice_has_message' = true);
[alicemessagetosn1] alice_sent_message_to_sn1 = true -> 1.0:(alice_sent_message_to_sn1' = false);

endmodule

module Bob
start_state: bool init true;
bob_sent_message_to_sn1: bool init false;
bob_sent_message_to_sn2: bool init false;

[] start_state = true -> 1.0:(bob_sent_message_to_sn1' = true) & (start_state' = false);
[bobmessagetosn1] bob_sent_message_to_sn1 = true -> 1.0:(bob_sent_message_to_sn1' = false);

endmodule

module Charlie
charlie_has_message: bool init false;

[sn1alicemessage] sn1alice_relays_message = true -> 1.0:(charlie_has_message' = true);
[sn1debbiemessage] sn1debbie_relays_message = true -> 1.0:(charlie_has_message' = true);
[sn2bobmessage] sn2bob_relays_message = true -> 1.0:(charlie_has_message' = true);

endmodule

module Debbie
debbie_has_message: bool init false;
debbie_sent_message_to_sn1: bool init false;

[] debbie_has_message = true -> 0.9:(debbie_has_message' = false) + 0.1:(debbie_has_message' = false) & (debbie_sent_message_to_sn1' = true);

[sn1bobmessage] sn1bob_relays_message = true -> 1.0:(debbie_has_message' = true);
[debbiemessagetosn1] debbie_sent_message_to_sn1 = true -> 1.0:(debbie_sent_message_to_sn1' = false);

endmodule

module SN1Alice
sn1alice_relays_message: bool init false;

[alicemessagetosn1] alice_sent_message_to_sn1 = true -> 1.0:(sn1alice_relays_message' = true);
[sn1alicemessage] sn1alice_relays_message = true -> (sn1alice_relays_message' = false);

endmodule

module SN1Bob
sn1bob_relays_message: bool init false;

[bobmessagetosn1] bob_sent_message_to_sn1 = true -> 1.0:(sn1bob_relays_message' = true);
[sn1bobmessage] sn1bob_relays_message = true -> (sn1bob_relays_message' = false);

endmodule

module SN1Debbie
sn1debbie_relays_message: bool init false;

[debbiemessagetosn1] debbie_sent_message_to_sn1 = true -> 1.0:(sn1debbie_relays_message' = true);
[sn1debbiemessage] sn1debbie_relays_message = true -> (sn1debbie_relays_message' = false);

endmodule

module SN2Bob
sn2bob_relays_message: bool init false;

[bobmessagetosn2] bob_sent_message_to_sn2 = true -> 1.0:(sn2bob_relays_message' = true);
[sn2bobmessage] sn2bob_relays_message = true -> (sn2bob_relays_message' = false);

endmodule




